;--------------------------------------------------------------------------------------------------
;			AxeAid
;			by Nathaniel van Diepen, fullmetal232@hotmail.com
;			July 20,2010
;			---Adapted From---
;				Document DE 7
;				by Kerm Martian, christopher@cemetech.net
;				May 20, 2010
;--------------------------------------------------------------------------------------------------
; Notes:
;    Oldsize contains a size only if there is an open file that is already saved.  Otherwise 0
;    SavedFilePtr contains a location if there is an already-saved file open. Otherwise 0
;    OpenFileFlag contains 0 for NO edit context, 1 for an edit context.  If this is 1 and
;		(SavedFilePtr) is 0, then the saveas routine needs to be invoked.
;--------------------------------------------------------------------------------------------------

;---Optional Defines---
;#define FADE			;only define if you want the fadin
;#define MOUSEINTRO		;only define if you want a mouse on the intro screen
#define SOUND			;only define if you want operational sound in the game
#define BlastIt		;only if you want the alternate error sound
#define ERROR_ICON		;only if you want the icon on the error reports
#define BETATEST		;turn on all the beta features

.nolist
#define TASMs
#define dispError(msg,msglength) ld hl,msg \ ld bc,msglength \ push bc \ call DisplayError
#include "ti83plus.inc"
#include "dcs7.inc"
#ifdef SOUND
#include "Sound.asm"
#endif

OpenFileFlag	.equ AppBackupScreen+94		;byte
SavedFilePtr	.equ AppBackupScreen+95		;word
OldSize			.equ AppBackupScreen+97		;word


.list
	.org $9d93
	.db $BB,$6D
INIT:
	xor d
	.db $C9
	jr Start
	.dw $0000
	.db $07,$00
	.dw Icon
	.dw $0000
	.dw Apstart			;the routine to open files.  DCS will start you here instead of at $9D95
						;if a file is pending
	.db $31,$7F			;argh, this be an APMain
	.db $01				;number of accepted filetypes
MyType1:				;accepted filetype
	.db 0,1,8
Icon:				;a 16x16 icon
	.db $3F,$F0
	.db $50,$10
	.db $90,$13
	.db $F3,$E1
	.db $82,$10
	.db $8E,$0B
	.db $89,$08
	.db $88,$8B
	.db $88,$4A
	.db $88,$31
	.db $84,$38
	.db $83,$DC
	.db $80,$0E
	.db $80,$17
	.db $80,$13
	.db $FF,$F1
IconAP:				;a 16x16 icon
	.db $0F,$FF
	.db $18,$01
	.db $28,$01
	.db $48,$01
	.db $F8,$01
	.db $81,$E1
	.db $87,$11
	.db $84,$91
	.db $84,$51
	.db $84,$31
	.db $82,$31
	.db $81,$D9
	.db $80,$0D
	.db $80,$07
	.db $80,$03
	.db $FF,$FF
START:                 ;main routines
	call Splash
	;first, set up pointers
	xor a
	ld h,a
	ld l,a
	ld (OpenFileFlag),a
	ld (SavedFilePtr),hl
	ld (OldSize),hl
RenderMain:
	call OpenGUIStack
	;now, set it up
	ld hl,LargeWinData
	ld de,LargeWinDataE-LargeWinData
	ld a,1
	call PushGUIStack
	ld hl,WinButtonsR
	ld de,WinButtonsE-WinButtonsR
	ld a,5
	call PushGUIStack
	ld hl,TaskbarIcons
	ld de,TaskbarIconsE-TaskbarIcons
	ld a,$11
	call PushGUIStack
	ld hl,HotspotNew
	ld de,6
	ld a,$0E
	call PushGUIStack
	ld hl,HotspotOpen
	ld de,6
	ld a,$0E
	call PushGUIStack
	ld hl,HotspotSaveAs
	ld de,6
	ld a,$0E
	call PushGUIStack
	ld hl,HotspotAbout
	ld de,6
	ld a,$0E
	call PushGUIStack
	ld hl,HotspotExport
	ld de,6
	ld a,$0E
	call PushGUIStack
	ld hl,HotspotTypes
	ld de,6
	ld a,$0E
	call PushGUIStack
	ld hl,Cursor
	ld de,CursorE-Cursor
	ld a,$18
	call PushGUIStack
RenderLoop:
	ld a,(OpenFileFlag)
	or a
	jr nz,DispTextbox
	ld hl,NullBox
	ld de,NullBoxE-NullBox
	ld a,$16
	call PushGUIStack
	jr RenderMain2
DispTextbox:
	ld hl,(SavedFilePtr)
	ld a,h
	or l
	jr nz,DispTextboxContents
	ld hl,Textboxheader
	ld de,TextboxheaderE-Textboxheader
	ld a,$0f
	call PushGUIStack
	ld hl,EditCursorS
	ld de,EditCursorSE-EditCursorS
	ld a,$18
	call PushGUIStack
	jr RenderMain2
DispTextboxContents:
	ld hl,(OldSize)
	ld de,TextboxHeaderE-TextboxHeader
	add hl,de
	ld de,-8
	add hl,de
	ld de,TextboxHeader
	ld a,$0f
	ex de,hl
	call PushGUIStack
	ld hl,EditCursorS
	ld de,EditCursorSE-EditCursorS
	ld a,$18
	call PushGUIStack
	call GetTextboxData
	push hl
	ld de,(SavedFilePtr)
	ld hl,8
	add hl,de
	pop de
	;ex de,hl
	ldir					;bc set by GetTextboxData
RenderMain2:
	ld hl,0
	call GUIMouse
AxeAidClose:
	call ResetAppPage
	call CheckSaveInvocation
	call CloseGUIStack
#ifdef SOUND
	call Quit.sound
#endif
	ret
Apstart:										;set up ap pointers now
	push ix
		pop hl
	ld de,-8
	add hl,de
	ld (SavedFilePtr),hl
	dec hl
	dec hl
	bcall(_ldhlind)
	ld (OldSize),hl
	ld a,1
	ld (OpenFileFlag),a
	jp RenderMain
NewFile:
	call ResetAppPage
#ifdef SOUND
	call Click.sound
#endif
	call CheckSaveInvocation
	ld a,1
	ld (OpenFileFlag),a
	ld hl,0
	ld (SavedFilePtr),hl
	ld (OldSize),hl
	call CloseGUIStack
	jp RenderMain
OpenFile:
	call ResetAppPage
#ifdef SOUND
	call Click.sound
#endif
	call CheckSaveInvocation
	xor a
	call FileOpen
	ld a,h
	or l
	jp z,RenderMain
	push de
		ld de,-8
		add hl,de
		ld (SavedFilePtr),hl
		pop hl
	bcall(_ldhlind)
	ld (OldSize),hl
	ld a,1
	ld (OpenFileFlag),a
	jp RenderMain
SaveFileAs:
   call ResetAppPage
#ifdef SOUND
	call Click.sound
#endif
   ld a,(OpenFileFlag)
   or a
   jp z,RenderMain
   ld hl,(SavedFilePtr)
   ld a,h
   or l
   call nz,CheckSaveInvocation
   ;*** do setup
   call getTextboxData         ;sets hl and bc
   ld de,MyType1
   xor a
   call FileSaveAs 
	ld a,h
	or l
	jp z,RenderMain
	push de
		inc de
		inc de
		ld (SavedFilePtr),de
		pop hl
	bcall(_ldhlind)
	ld (OldSize),hl
	ld a,1
	ld (OpenFileFlag),a
	;*** MUST CloseGUIStack and update ptrs from result
	call CloseGUIStack
	jp RenderMain
CheckSaveInvocation:
	ld a,(OpenFileFlag)
	or a
	ret z
	ld hl,(SavedFilePtr)
	ld a,h
	or l
	jr nz,CheckSaveUpdate
#ifdef SOUND
	call Error.sound
#endif
	call GetTextboxData
	ld de,MyType1
	xor a
	call FileSaveAs
	ld a,h
	or l
	jr nz,CheckSaveInvocation_Saved
	xor a
	ld (OpenFileFlag),a
	ret
CheckSaveInvocation_Saved:
	push de
	inc de
	inc de
	ld (SavedFilePtr),de
	pop hl
	bcall(_ldhlind)
	ld (OldSize),hl
	ld a,1
	ld (OpenFileFlag),a
	ret
CheckSaveUpdate:
	;*** update existing pointers and data
	ld hl,(SavedFilePtr)
	ld de,8
	add hl,de
	push hl
	ld hl,-8
	ld de,(OldSize)
	add hl,de
	pop de
	push de
	ex de,hl
	bcall(_delmem)
	;ld hl,8
	;ld (SavedFilePtr),hl
	;*** update size bytes
	call GetTextboxData
	push bc
	pop hl
	ld de,8
	add hl,de
	ld (OldSize),hl
	push bc
	pop hl
	pop de
	push de
	bcall(_insertmem)
	ld hl,(SavedFilePtr)
	dec hl
	dec hl
	ld de,(OldSize)
	ld (hl),e
	inc hl
	ld (hl),d
	;*** insert required # of byte
	call GetTextboxData
	pop de
	ldir
	;*** now copy those bytes
	;*** update size bytes
	;second, add bc bytes at hl
	ret
GetTextboxData:
	call GUIFindFirst
	ld b,9
CheckSaveUpdateLoop:
	push bc
	call GUIFindNext
	pop bc
	djnz CheckSaveUpdateLoop
	push hl
	bcall(_ldhlind)
	ld de,-9					;7+size word+type byte
	add hl,de
	pop de
	ex de,hl
	push de
	ld de,9
	add hl,de
	pop bc
	; hl = data location
	; bc = data size
	ret
DispAbout:
	call ResetAppPage
#ifdef SOUND
	call Click.sound
#endif
	ld hl,SmallWinAbout
	ld de,SmallWinAboutE-SmallWinAbout
	ld a,2
	call PushGUIStack
	ld hl,SmallWinButtons
	ld de,SmallWinButtonsE-SmallWinButtons
	ld a,5
	call PushGUIStack
	ld hl,SmallWinAboutT1
	ld de,SmallWinAboutT2-SmallWinAboutT1
	ld a,4
	call PushGUIStack
	ld hl,SmallWinAboutT2
	ld de,SmallWinAboutT3-SmallWinAboutT2
	ld a,4
	call PushGUIStack
	ld hl,SmallWinAboutT3
	ld de,SmallWinAboutT4-SmallWinAboutT3
	ld a,4
	call PushGUIStack
	ld hl,SmallWinAboutT4
	ld de,SmallWinAboutT5-SmallWinAboutT4
	ld a,4
	call PushGUIStack
	ld hl,SmallWinAboutT5
	ld de,SmallWinAboutT6-SmallWinAboutT5
	ld a,4
	call PushGUIStack
	ld hl,0
	call GUIMouse
DispAboutClose:
	call ResetAppPage
	ld b,7
	call PopGUIStacks
	jp RenderMain2
LargeWinData:
	.db %10100000
	.db %01010000
	.db %10100000
	.db %01010000
	.db %00001000
	.db "AxeAid | Edit",0
LargeWinDataE:
WinButtonsR:
	;[which {-,[],X,00000}, onclick[-] {word}, onclick[] {word}, onclick[X] {word}]
	.db %00100000
	.dw 0,0
	.dw AxeAidClose
WinButtonsE:
HotspotNew:
	.db 0,0,7,7
	.dw NewFile
HotspotOpen:
	.db 8,0,11,7
	.dw OpenFile
HotspotSaveAs:
	.db 19,0,9,7
	.dw SaveFileAs
HotspotAbout:
	.db 28,0,9,7
	.dw DispAbout
HotspotExport:
	.db 37,0,10,7
	.dw AXEExport
HotspotTypes:
	.db 49,0,7,7
	.dw AXETypes
TaskbarIcons:
	.db 0,0,7,8
	.db %00000001,%00000000,%00100000,%00010000,%00001000,%01100001,%00000000
	.db %01111001,%00110000,%00100111,%11010011,%11001001,%11111001,%00000000
	.db %01001101,%01001111,%10101100,%11010110,%01101001,%11111001,%01111111
	.db %01000101,%01000000,%10101111,%11010000,%11001011,%10011101,%01010001
	.db %01000101,%01000000,%10101000,%01010001,%10001011,%10011101,%01110001
	.db %01000101,%01000000,%10101000,%01010000,%00001001,%11111001,%01111111
	.db %01111101,%01111111,%10101111,%11010001,%10001001,%11111001,%00000000
	.db %00000001,%00000000,%00100000,%00010000,%00001000,%01100001,%00000000
TaskbarIconsE:
NullBox:
	.db 0,9,94,45,%10101010
NullBoxE:
TextBoxHeader:
	.db -1,8,7,95,0,0,0
TextBoxHeaderE:

SmallWinAbout:
	.db 8,8
	.db %10100000
	.db %01010000
	.db %10100000
	.db %01010000
	.db %00001000
	.db "AxeAid | About",0
SmallWinAboutE:
SmallWinButtons:
	;[which {-,[],X,00000}, onclick[-] {word}, onclick[] {word}, onclick[X] {word}]
	.db %00100000
	.dw 0,0
	.dw DispAboutClose
SmallWinButtonsE:
SmallWinAboutT1:
	.db 1,1,0,"AxeAid v0.1",0
SmallWinAboutT2:
	.db 1,8,0,"By Nathaniel van Diepen",0
SmallWinAboutT3:
	.db 1,15,0,"July 26,2010",0
SmallWinAboutT4:
	.db 1,22,0,"www.omnimaga.org",0
SmallWinAboutT5:
	.db 1,29,0,"Used DocDE's source",0
SmallWinAboutT6:
Cursor:
	.db 7,0		;top corner
	.db 15,56	;bottom corner
	.db $3F		;mask
	.db $1F
	.db $8F
	.db $C7
	.db $83
	.db $83
	.db $83
	.db $C7
	.db $C0		;sprite
	.db $A0
	.db $50
	.db $28
	.db $74
	.db $64
	.db $44
	.db $38
CursorE:
EditCursorS:
	.db 16,0	;top corner
	.db 52,94	;bottom corner
	.db $5F		;mask
	.db $BF
	.db $BF
	.db $BF
	.db $BF
	.db $5F
	.db $FF
	.db $FF
	.db $A0		;sprite
	.db $40
	.db $40
	.db $40
	.db $40
	.db $A0
	.db $00
	.db $00
EditCursorSE:
#include "AXEExport.asm"
#include "AxeTypes.asm"
#include "Errors.asm"
#include "Splash.asm"
#include "sounds.asm"
.end
.end